#include <memory>

#include "GuiApplication.h"
#include "MainApplication.h"
#include "CommandLineArgs.h"

int main(int argc, char *argv[])
{
    auto command_line_args = CommandLineArgs::CreateUnique();
    command_line_args->Process(argc, argv);
    command_line_args->RecordLaunchPath();

	// Start the main app
	auto main_app = MainApplication::Create();
	main_app->Initialize(std::move(command_line_args));

	// Start the gui app
	auto gui_app = std::make_shared<GuiApplication>();
	gui_app->SetMainApplication(main_app);
	gui_app->Run();

	main_app->ShutDown();
	return 0;
}
