#pragma once

#include <memory>
#include <string>

class AudioDevice
{

private:

	std::string mName;
	unsigned mSampleRate;
	unsigned mNumChannels;
	unsigned mPeriod;
	std::size_t mBufferSize;

public:

	AudioDevice();

	~AudioDevice();

	void SetSampleRate(unsigned rate);

	unsigned GetSampleRate();

	void SetName(const std::string& name);

	void SetNumChannels(unsigned numChannels);

	void SetPeriod(unsigned period);

	void SetBufferSize(std::size_t bufferSize);

	unsigned GetNumChannels();

	unsigned GetPeriod();

	std::size_t GetBufferSize();

	std::string GetName();

	static std::shared_ptr<AudioDevice> Create();
};

using AudioDevicePtr = std::shared_ptr<AudioDevice>;
