#include "AudioManager.h"

AudioManager::AudioManager()
	: mAudioDevices(),
	  mAudioInterface()
{
	mAudioInterface = AlsaInterface::Create();
}

AudioManager::~AudioManager()
{

}

std::shared_ptr<AudioManager> AudioManager::Create()
{
	return std::make_shared<AudioManager>();
}

void AudioManager::AddAudioDevice(AudioDevicePtr device)
{
	mAudioDevices.push_back(device);
}

AlsaInterfacePtr AudioManager::GetAudioInterface()
{
	return mAudioInterface;
}

std::vector<AudioDevicePtr> AudioManager::GetAudioDevices()
{
	return mAudioDevices;
}
