#pragma once

#include <memory>
#include <vector>

#include "AlsaInterface.h"
#include "AudioDevice.h"

class AudioManager
{

private:

	std::vector<AudioDevicePtr> mAudioDevices;
	AlsaInterfacePtr mAudioInterface;

public:

	AudioManager();

	~AudioManager();

	static std::shared_ptr<AudioManager> Create();

	void AddAudioDevice(AudioDevicePtr device);

	std::vector<AudioDevicePtr> GetAudioDevices();

	AlsaInterfacePtr GetAudioInterface();
};

using AudioManagerPtr = std::shared_ptr<AudioManager>;
