#pragma once

#include <memory>
#include <alsa/asoundlib.h>

#include "AudioDevice.h"

class AlsaInterface
{
	snd_pcm_t* mHandle;
	snd_pcm_hw_params_t* mHardwareParams;
	snd_pcm_uframes_t mPeriodSize;

public:

	AlsaInterface();

	~AlsaInterface();

	static std::shared_ptr<AlsaInterface> Create();

	void OpenDevice(AudioDevicePtr device);

	void SetAccessType(AudioDevicePtr device);

	void SetSampleFormat(AudioDevicePtr device);

	void SetSampleRate(AudioDevicePtr device);

	void SetPeriod(AudioDevicePtr device);

	void SetBufferSize(AudioDevicePtr device);

	void SetChannelNumber(AudioDevicePtr device);

	void Play(AudioDevicePtr device);
};

using AlsaInterfacePtr = std::shared_ptr<AlsaInterface>;
