#include "MetaMidiEvent.h"

MetaMidiEvent::MetaMidiEvent()
    : MidiEvent(),
      mType(Type::UNSET),
      mLabel(),
      mValue(0)
{

}

std::shared_ptr<MetaMidiEvent> MetaMidiEvent::Create()
{
    return std::make_shared<MetaMidiEvent>();
}

void MetaMidiEvent::SetValue(int value)
{
    mValue = value;
}

bool MetaMidiEvent::IsTrackName(char c)
{
    return (c & META_TRACK_NAME) == META_TRACK_NAME;
}

bool MetaMidiEvent::IsSetTempo(char c)
{
    return (c & META_SET_TEMPO) == META_SET_TEMPO;
}

bool MetaMidiEvent::IsTimeSignature(char c)
{
    return (c & META_TIME_SIG) == META_TIME_SIG;
}

void MetaMidiEvent::SetIsSetTempo()
{
    mType = Type::SET_TEMPO;
}

void MetaMidiEvent::SetIsTrackName()
{
    mType = Type::TRACK_NAME;
}

void MetaMidiEvent::SetIsTimeSignature()
{
    mType = Type::TIME_SIGNATURE;
}

void MetaMidiEvent::SetLabel(const std::string& label)
{
    mLabel = label;
}
