#pragma once

#include <memory>

class MidiEvent
{
    static const int META_EVENT = 0xFF;  // 1111 1111
    static const int SYSEX_EVENT = 0xF0;
    static const int DIVIDED_SYSEX_EVENT = 0xF7;
    int mTimeDelta;

public:

    MidiEvent();
    virtual ~MidiEvent() = default;

    static std::shared_ptr<MidiEvent> Create();

    void SetTimeDelta(int delta);
    static bool IsMetaEvent(char c);
    static bool IsSysExEvent(char c);
    static bool IsNormalSysExEvent(char c);
    static bool IsDividedSysExEvent(char c);
};

using MidiEventPtr = std::shared_ptr<MidiEvent>;
