#include "FileLogger.h"
#include <ctime>
#include <iomanip>


FileLogger::~FileLogger()
{

}

void FileLogger::SetWorkDirectory(const std::string& workDir)
{
	mWorkDirectory = workDir;
}

void FileLogger::SetFileName(const std::string& fileName)
{
	mFileName = fileName;
}

void FileLogger::Open()
{
	mFileStream.open(mWorkDirectory + "/" + mFileName);
}

void FileLogger::Close()
{
	mFileStream.close();
}

void FileLogger::LogLine(const std::string& line)
{
	mFileStream << line << std::endl;
}

void FileLogger::LogLine(const std::string& logType, const std::string& line, const std::string& fileName, const std::string& functionName, int lineNumber)
{
	std::time_t t = std::time(nullptr);
	const std::string cleanedFileName = fileName.substr(fileName.find_last_of("/\\") + 1);
	mFileStream << logType << "|" << std::put_time(std::gmtime(&t), "%T") << "|" << cleanedFileName << "::" << functionName << "::" << lineNumber << "|" << line <<  std::endl;
}
