#pragma once
#define MLOG_INFO(msg) FileLogger::GetInstance().LogLine("Info", msg, __FILE__, __FUNCTION__, __LINE__);
#define MLOG_ERROR(msg) FileLogger::GetInstance().LogLine("Error", msg, __FILE__, __FUNCTION__, __LINE__);

#include <memory>
#include <string>
#include <fstream>

class FileLogger
{
	std::string mWorkDirectory;

	std::string mFileName;

	std::ofstream mFileStream;

	FileLogger()
		:mWorkDirectory(),
		 mFileName("MT_Log.txt"),
		 mFileStream()
	{

	}

public:

    static FileLogger& GetInstance()
    {
        static FileLogger instance;
        return instance;
    }

	FileLogger(FileLogger const&) = delete;
    void operator=(FileLogger const&)  = delete;

	~FileLogger();

	void SetWorkDirectory(const std::string& workDir);

	void SetFileName(const std::string& fileName);

	void Open();

	void Close();

	void LogLine(const std::string& line);

	void LogLine(const std::string& logType, const std::string& line, const std::string& fileName = "", const std::string& functionName = "", int lineNumber=-1);

};

using FileLoggerPtr = std::shared_ptr<FileLogger>;
