#include "NetworkManager.h"

NetworkManager::NetworkManager()
	: mActiveSockets(),
	  mSocketInterface()
{

}

NetworkManager::~NetworkManager()
{

}

std::shared_ptr<NetworkManager> NetworkManager::Create()
{
	return std::make_shared<NetworkManager>();
}

void NetworkManager::Initialize()
{
	mSocketInterface = UnixSocketInterface::Create();
}

void NetworkManager::RunHttpServer()
{
	auto socket = Socket::Create();
	mSocketInterface->CreateSocket(socket);
	mSocketInterface->Listen(socket);
	mSocketInterface->Run(socket);
}

void NetworkManager::ShutDown()
{

}
