#pragma once

#include <memory>
#include <map>
#include <cstddef>

#include "Socket.h"

class UnixSocketInterface
{
	using SocketHandle = int;
	std::map<SocketPtr, SocketHandle> mOpeningHandles;
	std::size_t mBufferSize;

public:

	UnixSocketInterface();

	~UnixSocketInterface();

	static std::shared_ptr<UnixSocketInterface> Create();

	void CreateSocket(SocketPtr socket);

	void Listen(SocketPtr socket);

	void Run(SocketPtr socket);
};

using UnixSocketInterfacePtr = std::shared_ptr<UnixSocketInterface>;
