#pragma once

#include <memory>
#include <vector>

#include "PaintEvent.h"
#include "MouseEvent.h"
#include "VisualLayer.h"
#include "Widget.h"

namespace mt
{

class Window
{

private:

	WidgetPtr mWidget;
	unsigned mWidth;
	unsigned mHeight;
	std::vector<VisualLayerPtr> mLayers;

public:

	Window();

	~Window();

	static std::shared_ptr<Window> Create();

	void AddWidget(WidgetPtr widget);

	WidgetPtr GetWidget();

	std::vector<VisualLayerPtr> GetLayers();

	unsigned GetWidth();

	unsigned GetHeight();

	void SetSize(unsigned width, unsigned height);

	void OnPaint(PaintEventPtr event);

	void OnMouseEvent(MouseEventPtr event);
};
}

using WindowPtr = std::shared_ptr<mt::Window>;
