#include "KeyboardEvent.h"

KeyboardEvent::KeyboardEvent()
	: UiEvent(),
	  mAction(),
	  mKeyString()
{
	mType = UiEvent::Type::Keyboard;
}

KeyboardEvent::~KeyboardEvent()
{

}

std::shared_ptr<KeyboardEvent> KeyboardEvent::Create()
{
	return std::make_shared<KeyboardEvent>();
}

void KeyboardEvent::SetKeyString(const std::string& key)
{
	mKeyString = key;
}

std::string KeyboardEvent::GetKeyString()
{
	return mKeyString;
}

void KeyboardEvent::SetAction(Action action)
{
	mAction = action;
}

KeyboardEvent::Action KeyboardEvent::GetAction()
{
	return mAction;
}
