#pragma once

#include <memory>
#include <string>

#include "UiEvent.h"

class KeyboardEvent : public UiEvent
{
public:
	enum class Action
	{
		Pressed,
		Released
	};

private:

	Action mAction;
	std::string mKeyString;

public:

	KeyboardEvent();

	~KeyboardEvent();

	static std::shared_ptr<KeyboardEvent> Create();

	void SetKeyString(const std::string& key);

	std::string GetKeyString();

	void SetAction(Action action);

	Action GetAction();

};
using KeyboardEventPtr = std::shared_ptr<KeyboardEvent>;
