#include "MouseEvent.h"

MouseEvent::MouseEvent()
	: UiEvent(),
	  mClientLocation(0, 0),
	  mScreenLocation(0, 0),
	  mAction()
{
	mType = UiEvent::Type::Mouse;
}

MouseEvent::~MouseEvent()
{

}

std::shared_ptr<MouseEvent> MouseEvent::Create()
{
	return std::make_shared<MouseEvent>();
}

void MouseEvent::SetClientLocation(Pixel location)
{
	mClientLocation = location;
}

void MouseEvent::SetScreenLocation(Pixel location)
{
	mScreenLocation = location;
}

void MouseEvent::SetAction(MouseEvent::Action action)
{
	mAction = action;
}

Pixel MouseEvent::GetClientLocation()
{
	return mClientLocation;
}

Pixel MouseEvent::GetScreenLocation()
{
	return mScreenLocation;
}

MouseEvent::Action MouseEvent::GetAction()
{
	return mAction;
}

