#pragma once

#include "Color.h"

class GeometryElement
{
public:

	enum class Type
	{
		Path,
		Rectangle,
		Circle,
		Arc
	};

private:

	ColorPtr mFillColor;
	ColorPtr mStrokeColor;
	unsigned mStrokeThickness;
	Type mType;

public:

	GeometryElement();
	virtual ~GeometryElement() = default;

	ColorPtr GetFillColor();
	ColorPtr GetStrokeColor();
	unsigned GetStrokeThickness();
	virtual Type GetType() = 0;

	void SetFillColor(ColorPtr color);
	void SetStrokeColor(ColorPtr color);
	void SetStrokeThickness(unsigned thickness);
};

using GeometryElementPtr = std::shared_ptr<GeometryElement>;
