#include "RectangleElement.h"

RectangleElement::RectangleElement(const DiscretePoint& loc,
			unsigned width, unsigned height)
	: mLocation(loc),
	  mWidth(width),
	  mHeight(height)
{

}

std::shared_ptr<RectangleElement> RectangleElement::Create(const DiscretePoint& loc,
		unsigned width, unsigned height)
{
	return std::make_shared<RectangleElement>(loc, width, height);
}

GeometryElement::Type RectangleElement::GetType()
{
	return GeometryElement::Type::Rectangle;
}

DiscretePoint RectangleElement::GetLocation()
{
	return mLocation;
}

unsigned RectangleElement::GetWidth()
{
	return mWidth;
}

unsigned RectangleElement::GetHeight()
{
	return mHeight;
}
