#include "TextElement.h"

TextElement::TextElement(const std::string& content, const DiscretePoint& loc)
	: mContent(content),
	  mLocation(loc),
	  mFontLabel("fixed")
{

}

TextElement::~TextElement()
{

}

std::shared_ptr<TextElement> TextElement::Create(const std::string& content, const DiscretePoint& loc)
{
	return std::make_shared<TextElement>(content, loc);
}

DiscretePoint TextElement::GetLocation()
{
	return mLocation;
}

void TextElement::SetContent(const std::string& content)
{
	mContent = content;
}

std::string TextElement::GetFontLabel()
{
	return mFontLabel;
}

std::string TextElement::GetContent()
{
	return mContent;
}
