#pragma once

#include <memory>
#include <string>

#include "DiscretePoint.h"

class TextElement
{
	std::string mContent;
	DiscretePoint mLocation;
	std::string mFontLabel;

public:

	TextElement(const std::string& content, const DiscretePoint& loc);

	~TextElement();

	static std::shared_ptr<TextElement> Create(const std::string& content, const DiscretePoint& loc);

	DiscretePoint GetLocation();

	std::string GetContent();

	void SetContent(const std::string& content);

	std::string GetFontLabel();
};

using TextElementPtr = std::shared_ptr<TextElement>;
