#include "VisualLayer.h"

VisualLayer::VisualLayer()
	: mShape(),
	  mText()
{

}

std::shared_ptr<VisualLayer> VisualLayer::Create()
{
	return std::make_shared<VisualLayer>();
}

void VisualLayer::SetShape(GeometryElementPtr shape)
{
	mShape = shape;
}
void VisualLayer::SetText(TextElementPtr text)
{
	mText = text;
}
bool VisualLayer::HasShape()
{
	return bool(mShape);
}
bool VisualLayer::HasText()
{
	return bool(mText);
}
GeometryElementPtr VisualLayer::GetShape()
{
	return mShape;
}
TextElementPtr VisualLayer::GetText()
{
	return mText;
}
