#pragma once
#include <memory>

#include "GeometryElement.h"
#include "TextElement.h"

class VisualLayer
{
	GeometryElementPtr mShape;
	TextElementPtr mText;

public:

	VisualLayer();

	static std::shared_ptr<VisualLayer> Create();

	void SetShape(GeometryElementPtr shape);
	void SetText(TextElementPtr text);
	bool HasShape();
	bool HasText();
	GeometryElementPtr GetShape();
	TextElementPtr GetText();

};
using VisualLayerPtr = std::shared_ptr<VisualLayer>;
