#include "WindowManager.h"

WindowManager::WindowManager()
	: mWindows()
{
	AddWindow(mt::Window::Create());
}

WindowManager::~WindowManager()
{

}

void WindowManager::OnPaintEvent(PaintEventPtr event)
{
	GetMainWindow()->OnPaint(event);
}

void WindowManager::OnMouseEvent(MouseEventPtr event)
{
	GetMainWindow()->OnMouseEvent(event);
}

void WindowManager::AddWindow(WindowPtr window)
{
	mWindows.push_back(window);
}

std::shared_ptr<WindowManager> WindowManager::Create()
{
	return std::make_shared<WindowManager>();
}

WindowPtr WindowManager::GetMainWindow()
{
	return mWindows[0];
}
