#pragma once

#include <vector>
#include <memory>

#include "Window.h"
#include "PaintEvent.h"
#include "MouseEvent.h"


class WindowManager
{

private:

	std::vector<WindowPtr> mWindows;

public:

	WindowManager();

	~WindowManager();

	void AddWindow(WindowPtr window);

	static std::shared_ptr<WindowManager> Create();

	WindowPtr GetMainWindow();

	void OnPaintEvent(PaintEventPtr event);

	void OnMouseEvent(MouseEventPtr event);

};

using WindowManagerPtr = std::shared_ptr<WindowManager>;
