#pragma once
#include <GL/glx.h>
#include <xcb/xcb.h>
#include <memory>

class GlxInterface
{
	GLXContext mContext;
	GLXDrawable mDrawable;
	GLXWindow mWindow;
	GLXFBConfig mConfig;

public:

	GlxInterface();

	void SetupContext(Display* display, int default_screen);

	bool SetupWindow(Display* display, xcb_window_t window);

	void DestroyWindow(Display* display);

	void DestroyContext(Display* display);

	void SwapBuffers(Display* display);

	void Draw();

	static std::shared_ptr<GlxInterface> Create();
};

using GlxInterfacePtr = std::shared_ptr<GlxInterface>;
